"use strict";
/*
 * Module dependencies
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var path_1 = require("path");
var mkdir = require("make-dir");
var pall_1 = require("../utils/pall");
var compile_1 = require("./compile");
var del = require("del");
var fs = require("mz/fs");
function Build(params) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var _this = this;
        var root, outpath, files, dir, err;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    root = params.root ? path_1.resolve(process.cwd(), params.root) : process.cwd();
                    outpath = path_1.resolve(root, params.outpath || 'site');
                    return [4 /*yield*/, compile_1.default(params)];
                case 1:
                    files = _a.sent();
                    if (files instanceof Error)
                        return [2 /*return*/, files
                            // delete the existing outpath
                        ];
                    // delete the existing outpath
                    return [4 /*yield*/, del(outpath)];
                case 2:
                    // delete the existing outpath
                    _a.sent();
                    return [4 /*yield*/, mkdir(outpath)];
                case 3:
                    dir = _a.sent();
                    return [4 /*yield*/, pall_1.default(files.map(function (f) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
                            var filepath;
                            return tslib_1.__generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        filepath = path_1.join(dir, f.path);
                                        return [4 /*yield*/, mkdir(path_1.dirname(filepath))];
                                    case 1:
                                        _a.sent();
                                        fs.writeFile(filepath, f.contents, 'utf8');
                                        return [2 /*return*/];
                                }
                            });
                        }); }))];
                case 4:
                    err = _a.sent();
                    if (err instanceof Error)
                        return [2 /*return*/, err];
                    return [2 /*return*/, files];
            }
        });
    });
}
exports.default = Build;
