"use strict";
//
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
/*
 * Module dependencies
 */
// import * as WebpackDevMiddleware from 'webpack-dev-middleware'
// import * as WebpackHotMiddleware from 'webpack-hot-middleware'
var webpack_1 = require("../server/config/webpack");
var MemoryFS = require("memory-fs");
var routes_1 = require("../server/routes");
var Webpack = require("webpack");
var pall_1 = require("../utils/pall");
var path_1 = require("path");
function serve(params) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var root, env, aliases, fs, routes, s, b, configs, webpack;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    root = params.root ? path_1.resolve(process.cwd(), params.root) : process.cwd();
                    env = params.environment || 'development';
                    aliases = params.aliases || {};
                    fs = new MemoryFS();
                    return [4 /*yield*/, routes_1.default(root)
                        // start loading the server-side config
                    ];
                case 1:
                    routes = _a.sent();
                    s = webpack_1.default({
                        environment: env,
                        target: 'server',
                        action: 'serve',
                        routes: routes,
                        aliases: aliases,
                        root: root
                    });
                    b = webpack_1.default({
                        environment: env,
                        target: 'browser',
                        action: 'serve',
                        routes: routes,
                        aliases: aliases,
                        root: root
                    });
                    return [4 /*yield*/, pall_1.default([s, b])];
                case 2:
                    configs = _a.sent();
                    if (configs instanceof Error)
                        return [2 /*return*/, configs
                            // build the configurations in parallel
                        ];
                    webpack = Webpack(configs);
                    webpack.outputFileSystem = fs;
                    return [2 /*return*/, webpack];
            }
        });
    });
}
exports.default = serve;
