export interface HTMLNode {
    type: string;
    children?: HTMLNode[];
}
export interface HTMLText extends HTMLNode {
    type: 'text';
    value: string;
}
export interface HTMLElement extends HTMLNode {
    type: 'element';
    tagName: string;
    properties: {
        [attr: string]: string;
    };
}
export interface Options {
    resolve?: (node: HTMLElement) => string;
}
export declare function JS(code: string, options?: Options): string;
