export declare type URL = {
    protocol: string;
    host: string;
    port: number;
    hostname: string;
    hash: string;
    search: string;
    query: {
        [s: string]: string | boolean;
    };
    pathname: string;
    href: string;
};
export declare type Route = {
    path: string;
    regexp: string;
    params: (string | number)[];
};
/**
 * Router
 */
export default class Router {
    routes: Route[];
    cache: {
        [path: string]: any;
    };
    constructor(routes?: Route[]);
    onPopState(_e: PopStateEventInit): Promise<void>;
    push(url: string): Promise<void>;
    error(err: Error): void;
    replace(url: string): Promise<void>;
    possLoad(url: string): Promise<any>;
    load(as: string): Promise<void>;
    get(url: string): Promise<{
        default: undefined;
    } | null | undefined>;
    update(Component: any, path: string): Promise<void>;
    renderComponent(Component: any, url: URL, params: Object): Promise<void>;
    getURL(): string;
    evaluate(script: string): {
        default: undefined;
    } | undefined;
    private findRoute(path);
}
