"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.development = function (_params) {
    return {
        // sourceRoot: params.root,
        sourceMaps: true,
        presets: [
            [
                require.resolve('babel-preset-env'),
                {
                    targets: {
                        chrome: 56,
                        node: 7
                    }
                    // modules: false
                }
            ]
        ],
        plugins: [
            require.resolve('babel-plugin-transform-class-properties'),
            require.resolve('styled-jsx/babel'),
            [require.resolve('babel-plugin-transform-react-jsx'), { pragma: 'h' }]
        ]
    };
};
exports.production = function (_params) {
    return {
        // sourceRoot: params.root,
        sourceMaps: true,
        presets: [require.resolve('babel-preset-env')],
        plugins: [
            require.resolve('babel-plugin-transform-class-properties'),
            [
                require.resolve('babel-plugin-transform-runtime'),
                { polyfill: false, useBuiltIns: true, useESModules: true }
            ],
            require.resolve('styled-jsx/babel'),
            [require.resolve('babel-plugin-transform-react-jsx'), { pragma: 'h' }]
        ]
    };
};
exports.typescript = function (_params) {
    return {
        sourceMaps: true,
        plugins: [
            require.resolve('styled-jsx/babel'),
            [require.resolve('babel-plugin-transform-react-jsx'), { pragma: 'h' }]
        ]
    };
};
