"use strict";
/**
 * Dependencies
 */
Object.defineProperty(exports, "__esModule", { value: true });
// import parseHTML from 'rehype-parser'
// import Transform from '../../lib/style/transform'
// import { validate } from '../config/tsconfig'
var mdx_1 = require("../../lib/mdx");
var toSlug = require("to-slug-case");
var path_1 = require("path");
// import * as ts from 'typescript'
/**
 * Export the `loader`
 */
function default_1(source, _sourceMap) {
    this.cacheable();
    var _a = this, resourcePath = _a.resourcePath, root = _a.query.root;
    var resolve = function (node) { return resolver(root, node); };
    // compile MDX
    var result = '';
    try {
        result = mdx_1.JS(source, { resolve: resolve });
    }
    catch (err) {
        err.stack =
            "mdx loader: error loading '" + resourcePath + "'\n\n" + (err.stack || '');
        this.callback(err);
        return;
    }
    this.callback(null, result, undefined);
}
exports.default = default_1;
// Opinionated Resolver for Elmo:
//
// <Link> => ./components/link or ./components/link/index
//
// <h1>   => ./components/h1 or ./components/h1/index
//
// <Gallery:Video> => ./components/gallery/video
//                 or ./components/gallery/video/index
//
function resolver(root, node) {
    var p = './' + toSlug(node.tagName.replace(':', path_1.sep));
    return requires(path_1.join(root, 'components', p + '.tsx'), path_1.join(root, 'components', p + '.jsx'), path_1.join(root, 'components', p, 'index.tsx'), path_1.join(root, 'components', p, 'index.jsx'));
}
/**
 * Requires
 */
function requires() {
    var paths = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        paths[_i] = arguments[_i];
    }
    for (var i = 0; i < paths.length; i++) {
        try {
            return require.resolve(paths[i]);
        }
        catch (err) { }
    }
    return '';
}
