"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ts = require("typescript");
var transform_1 = require("../../lib/style/transform");
var typescript_1 = require("../../utils/typescript");
// import { validate } from '../config/tsconfig'
function default_1(source, _sourceMap) {
    var _a = this, path = _a.resourcePath, _b = _a.query, root = _b.root, environment = _b.environment, target = _b.target;
    // mark loader as cacheable
    this.cacheable();
    // setup styled-tsx
    var hasRuntime = environment !== 'production' || target !== 'browser';
    var transformers = {
        before: [
            visitor(transform_1.default({
                runtime: hasRuntime,
                target: target
            }))
        ]
    };
    // transpile
    var result = typescript_1.default({ root: root, path: path, source: source, transformers: transformers, target: target });
    if (result instanceof Error)
        return this.callback(result);
    return this.callback(null, result.outputText);
}
exports.default = default_1;
function visitor(transform) {
    return function (context) {
        return function (sourceFile) {
            return visit(sourceFile);
            function visit(node) {
                var t = transform[node.kind];
                if (!t) {
                    return ts.visitEachChild(node, visit, context);
                }
                // enter a node
                if (typeof t === 'object' && t.enter) {
                    var tr = t.enter(node, context);
                    if (tr)
                        node = tr;
                }
                // if it's a function, treat it
                // the same way as t.enter
                if (typeof t === 'function') {
                    var tr = t(node, context);
                    if (tr)
                        node = tr;
                }
                // visit each child
                var exitNode = ts.visitEachChild(node, visit, context);
                // if we have an exit call function
                if (typeof t === 'object' && t.exit) {
                    var tr = t.exit(exitNode, context);
                    if (tr)
                        exitNode = tr;
                }
                return exitNode;
            }
        };
    };
}
