/// <reference types="webpack" />
import { Route } from '../../elmo';
import { Plugin, Compiler } from 'webpack';
export declare type Entries = {
    [s: string]: {
        source: () => string;
        size: () => number;
    };
};
export declare type EntryPaths = {
    [entry: string]: string;
};
export declare type StaticParams = {
    environment: string;
    elmoRoot: string;
    target: string;
    action: string;
    root: string;
    routes: Route[];
    port?: number;
};
/**
 * Module Exports
 */
export default class Static implements Plugin {
    private readonly options;
    constructor(options: StaticParams);
    build(entries: Entries): Promise<void | Error>;
    apply(compiler: Compiler): void;
}
