import { Document } from 'elmo'
const { Head, Page, Scripts } = Document
import { h } from 'preact'

const site = {
  title: 'Elmo Site',
  favicon: '/static/favicon.ico',
  language: 'en',
  description: 'This is an incredible website powered by Elmo',
  url: 'http://mat.tm',
  card: 'https://mat.tm/joy/images/twitter.png',
  twitter: '@mattmueller'
}

export default class CustomDocument extends Document {
  render() {
    return (
      <html class="no-js" lang={site.language}>
        <Head>
          <title>{site.title}</title>
          <meta name="description" content={site.description} />
          <meta property="og:title" content={site.title} />
          <meta property="og:url" content={site.url} />
          <meta property="og:description" content={site.description} />
          <meta property="og:image:type" content="image/png" />
          <meta property="og:image:width" content="940" />
          <meta property="og:image:height" content="550" />
          <meta property="og:image" content={`${site.url}/__CARD__`} />

          <meta name="twitter:card" content="summary_large_image" />
          <meta name="twitter:site" content={site.twitter} />
          <meta name="twitter:creator" content={site.twitter} />
          <meta name="twitter:image" content={`${site.url}/__CARD__`} />

          <link rel="shortcut icon" href={site.favicon} />
          <link rel="icon" sizes="16x16 32x32" href={site.favicon} />

          <meta name="viewport" content="width=device-width, initial-scale=1" />

          <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
          <meta charSet="utf-8" />
        </Head>
        <body>
          <Page />
          <Scripts />
        </body>
      </html>
    )
  }
}
