import { URL } from './client/url'

export interface BuildProps {
  // TODO: improve build props
}

export interface InitialProps {
  params: { [param: string]: string }
  url: URL
}

export type File = {
  path: string
  contents: string
}

export interface Route {
  path: string
  regexp: string
  params: (string | number)[]
}

export interface Params {
  environment: string
  outpath: string
  target: string
  action: string
  root: string
  routes: Route[]
  port?: number
}

export { default as Document } from './lib/_document'
export { default as Router } from './lib/router'
export { default as Link } from './lib/link'
export { default as Head } from './lib/head'

import * as url from './client/url'
import * as qs from './client/qs'
export { url, qs }
