import { relative, basename, join, dirname, extname } from 'path'

// Turn the path into a route
//
// e.g.
//  - index.js        => /
//  - about.js        => /about
//  - movies/index.js => /movies
//  - index/index.js  => /
export default function Route(root: string, entry: string): string {
  const page = relative(join(root, 'pages'), entry)
  const base = basename(page, extname(page))
  if (base === 'index') {
    let dir = dirname(page)
    while (dir === 'index') {
      dir = dirname(dir)
    }
    return dir === '.' ? '/' : '/' + dir
  } else {
    return '/' + base
  }
}
