import { Compiler, compilation, Plugin } from 'webpack'
import globby from '../../utils/glob'
import { join } from 'path'

export namespace Watcher {
  export interface Input {
    root: string
  }
}

export default class Watcher implements Plugin {
  constructor(private readonly input: Watcher.Input) {}

  async find(compilation: compilation.Compilation): Promise<void | Error> {
    const { root } = this.input
    const pages = await globby(root, join('pages', '**'))
    const files = (compilation as any).fileDependencies
    pages.map(page => files.add(page))
  }

  apply(compiler: Compiler) {
    this.input as any
    compiler.hooks.afterCompile.tapAsync(
      'watcher',
      (compilation: compilation.Compilation, done: (err?: Error) => void) => {
        this.find(compilation)
          .then(() => done())
          .catch(err => done(err))
      }
    )
  }
}
