import flatten = require('lodash/flatten')
import uniq = require('lodash/uniq')
import * as globby from 'globby'

export default async function Glob(
  root: string,
  ...patterns: string[]
): Promise<string[]> {
  const filegroups = await Promise.all(
    patterns.map(pattern => {
      // TODO: will globby throw?
      return globby(pattern, {
        absolute: true,
        cwd: root,
        dot: false,
        ignore: ['**/node_modules/**', 'testdata/']
      })
    })
  )
  return uniq(flatten(filegroups))
}
