import CustomError from './error'

export default class MultiError extends CustomError {
  public readonly errors: Error[]

  constructor(errors: Error[]) {
    super(message(errors))
    this.errors = errors
  }
}

function message(errors: Error[]): string {
  return errors
    .map(err => {
      return err.message || err
    })
    .join('; ')
}
