import MultiError from './multi-error'
// import CustomError from './error'

export default async function Pall<T>(
  promises: Promise<T | Error>[]
): Promise<T[] | Error> {
  let results: (T | Error)[] = []

  try {
    results = await Promise.all(promises)
  } catch (err) {
    return err
  }

  const errors: Error[] = []
  const values: T[] = []
  for (let i = 0; i < results.length; i++) {
    const result = results[i]
    if (result instanceof Error) {
      errors.push(result)
    } else {
      values.push(result)
    }
  }

  if (errors.length == 1) return errors[0]
  if (errors.length > 1) return new MultiError(errors)

  return values
}
