import { relative, basename, join, dirname, extname } from 'path'

// Turn the path into a route
//
// e.g.
//  - index.js        => /
//  - about.js        => /about
//  - movies/index.js => /movies
//  - index/index.js  => /
export default function rewrite(
  root: string,
  target: string,
  page: string
): string {
  const rel = relative(join(root, 'pages'), page)
  const ext = target === 'server' ? '.html' : '.js'
  const base = basename(rel, extname(rel))
  let dir = dirname(rel)
  if (base === 'index') {
    if (dir === 'index') dir = dirname(dir)
    if (dir === '.') return base + ext
    return join(dir, base + ext)
  } else {
    return join(dir, base, 'index' + ext)
  }
}

// console.log(rewrite('/matt', 'server', '/matt/pages/index.jsx'))
// console.log(rewrite('/matt', 'browser', '/matt/pages/index.tsx'))
// console.log(rewrite('/matt', 'server', '/matt/pages/about/index.jsx'))
// console.log(rewrite('/matt', 'browser', '/matt/pages/about/index.tsx'))
// console.log(rewrite('/matt', 'server', '/matt/pages/about/sub.jsx'))
// console.log(rewrite('/matt', 'browser', '/matt/pages/about/sub.tsx'))
