declare module 'globby' {
  function sync(pattern: string | string[], options?: Options): string[]

  type Options = {
    absolute?: boolean
    ignore?: string[]
    cwd?: string
    root?: string
    dot?: boolean
    nomount?: boolean
    mark?: boolean
    nosort?: boolean
    stat?: boolean
    silent?: boolean
    strict?: boolean
    sync?: boolean
    nounique?: boolean
    nonull?: boolean
    debug?: boolean
    nobrace?: boolean
    noglobstar?: boolean
    noext?: boolean
    nocase?: boolean
    nodir?: boolean
    follow?: boolean
    realpath?: boolean
    nonegate?: boolean
    nocomment?: boolean
    cache?: any
    statCache?: any
    symlinks?: any
    realpathCache?: any
  }

  type Globby = {
    (pattern: string | string[], options?: Options): Promise<string[]>
    sync(pattern: string | string[], options?: Options): string[]
  }

  const globby: Globby
  export = globby
}
